Index: /trunk/src/sh_error.c
===================================================================
--- /trunk/src/sh_error.c	(revision 584)
+++ /trunk/src/sh_error.c	(revision 1)
@@ -1805,13 +1536,7 @@
 			     SH_ERR_STAMP | SH_ERR_ERR    | SH_ERR_SEVERE |
 			     SH_ERR_FATAL);
-  flag_err_info           = S_TRUE;
-#endif
-
-#if defined(SH_WITH_SERVER)
-  errFlags.exportlevel    = SH_ERR_NOT;
-#else
+#endif
   errFlags.exportlevel    = (SH_ERR_STAMP | SH_ERR_ERR    | SH_ERR_SEVERE |
 			     SH_ERR_FATAL);
-#endif
 
   errFlags.log_class      = 0xFFFF;
Index: /trunk/src/sh_extern.c
===================================================================
--- /trunk/src/sh_extern.c	(revision 584)
+++ /trunk/src/sh_extern.c	(revision 1)
@@ -40,5 +40,5 @@
 static FILE * pdbgc = NULL;
 #define PDBG_OPEN    if (pdbg == NULL) pdbg = fopen(PDGBFILE"main",  "a")  
-#define PDBG_CLOSE   sl_fclose (FIL__, __LINE__, pdbg); pdbg = NULL
+#define PDBG_CLOSE   fclose (pdbg); pdbg = NULL
 #define PDBG(arg)    fprintf(pdbg,  "PDBG: step %d\n", arg); fflush(pdbg)
 #define PDBG_D(arg)  fprintf(pdbg,  "PDBG: %d\n", arg); fflush(pdbg)
@@ -46,5 +46,5 @@
 
 #define PDBGC_OPEN   if (pdbgc == NULL) pdbgc = fopen(PDGBFILE"child", "a")  
-#define PDBGC_CLOSE  sl_fclose (FIL__, __LINE__, pdbgc); pdbgc = NULL
+#define PDBGC_CLOSE  fclose (pdbgc); pdbgc = NULL
 #define PDBGC(arg)   fprintf(pdbgc, "PDBGC: step %d\n", arg); fflush(pdbgc)
 #define PDBGC_D(arg) fprintf(pdbgc, "PDBGC: %d\n", arg); fflush(pdbgc)
@@ -74,8 +74,15 @@
 #include <sys/wait.h>
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
+#else
+#include <time.h>
 #endif
-#include <time.h>
+#endif
+
 
 #include "samhain.h"
@@ -85,5 +92,4 @@
 #include "sh_extern.h"
 #include "sh_calls.h"
-#include "sh_filter.h"
 #define SH_NEED_PWD_GRP 1
 #include "sh_static.h"
@@ -109,8 +115,7 @@
   FILE * outf = NULL;
   char * envp[1];
-  char * argp[2];
+  char * argp[1];
 
   char * errfile;
-  char errbuf[SH_ERRBUF_SIZE];
 
   static int some_error = 0;
@@ -121,29 +126,22 @@
   int         pfd = -1;
 #endif
-
+  
   SL_ENTER(_("sh_ext_popen"));
 
   /* Linux, HP-UX and FreeBSD will happily accept envp = argp = NULL
-   * (newer Linuxes (gcc 4.4.4) warn on argp == NULL, but accept it,
-   * as reported by T. Luettgert)
    * Solaris (and probably some other Unices) 
    *         needs a valid *envp[] with envp[0] = NULL;
    *         and similarly for argp
-   * OpenBSD finally needs non-null argp[0] ...
    */
-  argp[0] = task->command;
-  argp[1] = NULL;
   envp[0] = NULL;
+  argp[0] = NULL;
 
   /* 
    * --  check whether path is trustworthy
    */
-  status = sl_trustfile(task->command, NULL, NULL);
-#if 0
   if ((uid_t) -1 != task->trusted_users[0])
     {
       status = sl_trustfile(task->command, task->trusted_users, NULL);
     }
-#endif
 
   PDBG_OPEN;
@@ -180,13 +178,10 @@
    * --  check whether the checksum is correct; with linux emulate fdexec
    */
-#if ( !defined(__linux__) || ( defined(__linux__) && defined(HAVE_PTHREAD)) ) && !defined(SL_DEBUG)
+#if !defined(__linux__) && !defined(SL_DEBUG)
   if (task->checksum[0]  != '\0')
     {
-      char hashbuf[KEYBUF_SIZE];
       PDBG_S("checksum test");
       if (0 != sl_strcmp(task->checksum, 
-			 sh_tiger_hash (task->command, TIGER_FILE, TIGER_NOLIM,
-					hashbuf, sizeof(hashbuf))
-			 )
+			 sh_tiger_hash (task->command, TIGER_FILE, 0))
 	  )
 	{
@@ -216,15 +211,13 @@
       errnum = errno;
       sh_error_handle((-1), FIL__, __LINE__, errnum, MSG_E_SUBGEN, 
-		      sh_error_message(errnum, errbuf, sizeof(errbuf)), _("pipe"));
+		      sh_error_message(errnum), _("pipe"));
       SL_RETURN ((-1), _("sh_ext_popen"));
     }
 
   PDBG(3);
-
+  
   /* 
-   * -- Flush streams and fork 
+   * -- Fork 
    */
-  fflush (NULL);
-
   task->pid = aud_fork(FIL__, __LINE__);
 
@@ -233,10 +226,10 @@
       PDBG_S("fork() failure");
       /*@-usedef@*/
-      (void) sl_close_fd(FIL__, __LINE__, pipedes[0]);
-      (void) sl_close_fd(FIL__, __LINE__, pipedes[1]);
+      (void) close(pipedes[0]);
+      (void) close(pipedes[1]);
       /*@+usedef@*/
       errnum = errno;
       sh_error_handle((-1), FIL__, __LINE__, errnum, MSG_E_SUBGEN, 
-		      sh_error_message(errnum, errbuf, sizeof(errbuf)), _("fork"));
+		      sh_error_message(errnum), _("fork"));
       SL_RETURN ((-1), _("sh_ext_popen"));
     }
@@ -251,9 +244,9 @@
       if (S_TRUE == task->fork_twice)
 	{
-	  task->pid = fork();
+	  task->pid = aud_fork(FIL__, __LINE__);
 
 	  if (task->pid == (pid_t) - 1) 
 	    {
-	      _exit (EXIT_FAILURE);
+	      aud__exit (FIL__, __LINE__, EXIT_FAILURE);
 	    }
 	}
@@ -261,6 +254,4 @@
       if (task->pid == (pid_t) 0)
 	{
-	  int val_return;
-
 	  PDBGC_OPEN;
 	  PDBGC(1);
@@ -271,19 +262,13 @@
 	  if (task->rw == 'w')
 	    {
-	      do {
-		val_return = dup2 (pipedes[STDIN_FILENO], STDIN_FILENO);
-	      } while (val_return < 0 && errno == EINTR);
-
-	      if (val_return < 0)
-		_exit(EXIT_FAILURE);
+	      if (retry_aud_dup2(FIL__, __LINE__, 
+				 pipedes[STDIN_FILENO], STDIN_FILENO) < 0)
+		aud__exit(FIL__, __LINE__,EXIT_FAILURE);
 	    }
 	  else
 	    {
-	      do {
-		val_return = dup2 (pipedes[STDOUT_FILENO], STDOUT_FILENO);
-	      } while (val_return < 0 && errno == EINTR);
-
-	      if (val_return < 0)
-		_exit(EXIT_FAILURE);
+	      if (retry_aud_dup2(FIL__, __LINE__,
+				 pipedes[STDOUT_FILENO], STDOUT_FILENO) < 0)
+		aud__exit(FIL__, __LINE__,EXIT_FAILURE);
 	    }
 	  PDBGC(2);
@@ -292,11 +277,11 @@
 	  /* close the pipe descriptors 
 	   */
-	  (void) sl_close_fd   (FIL__, __LINE__, pipedes[STDIN_FILENO]);
-	  (void) sl_close_fd   (FIL__, __LINE__, pipedes[STDOUT_FILENO]);
+	  (void) close   (pipedes[STDIN_FILENO]);
+	  (void) close   (pipedes[STDOUT_FILENO]);
 	  
 	  /* don't leak file descriptors
 	   */
 #if !defined(PDGBFILE)
-	  sh_unix_closeall (3, task->com_fd, S_TRUE); /* in child process */
+	  sh_unix_closeall (3, task->com_fd); /* in child process */
 #endif
 
@@ -311,13 +296,10 @@
 	      memset(skey, 0, sizeof(sh_key_t));
 
-	      if (setgid((gid_t) task->run_user_gid) != 0)
-		_exit(EXIT_FAILURE);
-	      if (setuid((uid_t) task->run_user_uid) != 0)
-		_exit(EXIT_FAILURE);
-
+	      (void) aud_setgid(FIL__, __LINE__,(gid_t) task->run_user_gid);
+	      (void) aud_setuid(FIL__, __LINE__,(uid_t) task->run_user_uid);
 	      /* make sure we cannot get root again
 	       */
-	      if (setuid(0) >= 0)
-		_exit(EXIT_FAILURE);
+	      if (aud_setuid(FIL__, __LINE__,0) >= 0)
+		aud__exit(FIL__, __LINE__,EXIT_FAILURE);
 	    }
 	  
@@ -338,8 +320,6 @@
 	    {
 	      PDBGC_S("r");
-	      do {
-		val_return = dup2 (STDOUT_FILENO, STDERR_FILENO);
-	      } while (val_return < 0 && errno == EINTR);
-
+	      (void) retry_aud_dup2 (FIL__, __LINE__, 
+				     STDOUT_FILENO, STDERR_FILENO);
 	      (void) fcntl  (STDIN_FILENO, F_SETFD, FD_CLOEXEC);
 	      /*
@@ -355,101 +335,45 @@
 	   * --  emulate an fdexec with checksum testing
 	   */
-
-#if !defined(HAVE_PTHREAD)
 	  if (task->checksum[0]  != '\0')
-#endif
 	    {
 	      PDBGC_S("fexecve");
 	      if (task->com_fd != (-1))
 		{
-		  do {
-		    val_return = dup (task->com_fd);
-		  } while (val_return < 0 && errno == EINTR);
-		  pfd = val_return;
+		  pfd = retry_aud_dup(FIL__, __LINE__, task->com_fd);
 		  if (pfd < 0)
 		    {
-		      PDBGC_S("fexecve: dup failed");
-		      _exit(EXIT_FAILURE);
+		      PDBGC_S("fexecve: dup2 failed");
+		      aud__exit(FIL__, __LINE__, EXIT_FAILURE);
 		    }
 		}
-#if !defined(HAVE_PTHREAD)
 	      else
 		{
-		  char hashbuf[KEYBUF_SIZE];
-
 		  fd = 
-		    sl_open_read(FIL__, __LINE__, task->command, 
+		    sl_open_read(task->command, 
 				 task->privileged==0 ? SL_NOPRIV : SL_YESPRIV);
-
+		  tiger_fd = fd;
 		  if (0 != sl_strcmp(task->checksum, 
 				     sh_tiger_hash (task->command, 
-						    fd, TIGER_NOLIM, hashbuf, sizeof(hashbuf))))
+						    TIGER_FD, 0)))
 		    {
 		      PDBGC_S("fexecve: checksum mismatch");
-		      sl_close(fd);
-		      _exit(EXIT_FAILURE);
+		      aud__exit(FIL__, __LINE__, EXIT_FAILURE);
 		    }
-
 		  pfd = get_the_fd(fd);
-
-		  do {
-		    val_return = dup (pfd);
-		  } while (val_return < 0 && errno == EINTR);
-		  pfd = val_return;
-
-		  sl_close(fd);
-		  fd = -1;
-
-		  if (pfd < 0)
-		    {
-		      PDBGC_S("fexecve: dup (2) failed");
-		      _exit(EXIT_FAILURE);
-		    }
 		}
-#endif
               
 	      PDBGC(5);
-	      /* Cannot use sprintf because of deadlock in malloc/free */
-	      {
-		static char digit[] = "0123456789";
-		char str0[128];
-		char str1[128];
-		int ival = pfd;
-		unsigned int n = 0;
-		unsigned int m = 0;
-
-		if (ival < 0) ival = -ival;
-		do {
-		  str0[n] = digit[ival % 10];
-		  ++n;
-		  ival /= 10;
-		} while (ival);
-
-		if (pfd < 0)
-		  {
-		    str0[n] = '-';
-		    ++n;
-		  }
-		str0[n] = '\0';
-		str1[n] = '\0';
-		while (n > 0)
-		  {
-		    str1[m] = str0[n-1];
-		    ++m; --n;
-		  }
-		sl_strlcpy(pname, _("/proc/self/fd/"), sizeof(pname));
-		sl_strlcat(pname, str1, sizeof(pname));
-	      }
-              if (access(pname, R_OK|X_OK) == 0) /* flawfinder: ignore */
+	      sprintf(pname, _("/proc/self/fd/%d"),      /* known to fit  */
+			   pfd);
+              if (access(pname, R_OK|X_OK) == 0) 
 		{
 		  PDBGC(6);
 		  PDBGC_CLOSE;
 		  fcntl  (pfd, F_SETFD, FD_CLOEXEC);
-		  do {
-		    val_return = execve (pname, 
-					 (task->argc == 0) ? argp : task->argv, 
-					 (task->envc == 0) ? NULL : task->envv
-					 );
-		  } while (val_return < 0 && errno == EINTR);
+		  retry_aud_execve (FIL__, __LINE__, 
+				    pname, 
+				    (task->argc == 0) ? NULL : task->argv, 
+				    (task->envc == 0) ? NULL : task->envv
+				    );
 		  
 		  errnum = errno;
@@ -461,5 +385,5 @@
 		  /* failed 
 		   */
-		  _exit((errnum == 0) ? (EXIT_SUCCESS) : (EXIT_FAILURE));
+		  aud__exit(FIL__, __LINE__, EXIT_FAILURE);
               }
 	      PDBGC_S("fexecve: not working");
@@ -470,5 +394,5 @@
 		sl_close(fd);
 	      else if (pfd != -1)
-		sl_close_fd(FIL__, __LINE__, pfd);
+		close(fd);
 	    }
 #endif
@@ -478,14 +402,13 @@
 	   * --  execute path if executable
 	   */
-	  if (0 == access(task->command, R_OK|X_OK)) /* flawfinder: ignore */
+	  if (0 == access(task->command, R_OK|X_OK))
 	    {
 	      PDBGC(5);
 	      PDBGC_CLOSE;
-	      do {
-		val_return = execve (task->command, 
-				     (task->argc == 0) ? argp : task->argv, 
-				     (task->envc == 0) ? envp : task->envv
-				     );
-	      } while (val_return < 0 && errno == EINTR);
+	      (void) retry_aud_execve (FIL__, __LINE__, 
+				       task->command, 
+				       (task->argc == 0) ? argp : task->argv, 
+				       (task->envc == 0) ? envp : task->envv
+				       );
 	    }
 	  errnum = errno;
@@ -497,5 +420,5 @@
 	  /* failed 
 	   */
-	  _exit((errnum == 0) ? (EXIT_SUCCESS) : (EXIT_FAILURE));
+	  aud__exit(FIL__, __LINE__, EXIT_FAILURE);
 	}
       /* 
@@ -504,5 +427,5 @@
       if (S_TRUE == task->fork_twice)
 	{
-	  _exit (0);
+	  aud__exit (FIL__, __LINE__, 0);
 	}
     }
@@ -524,5 +447,5 @@
     {
       PDBG_S("is w");
-      (void) sl_close_fd (FIL__, __LINE__, pipedes[STDIN_FILENO]);
+      (void) close (pipedes[STDIN_FILENO]);
       (void) retry_fcntl (FIL__, __LINE__, pipedes[STDOUT_FILENO], 
 			  F_SETFD, FD_CLOEXEC);
@@ -532,5 +455,5 @@
     {
       PDBG_S("is r");
-      (void) sl_close_fd (FIL__, __LINE__, pipedes[STDOUT_FILENO]);
+      (void) close (pipedes[STDOUT_FILENO]);
       (void) retry_fcntl (FIL__, __LINE__, pipedes[STDIN_FILENO], 
 			  F_SETFD, FD_CLOEXEC);
@@ -554,6 +477,6 @@
 
       (void) aud_kill (FIL__, __LINE__, task->pid, SIGKILL);
-      (void) sl_close_fd (FIL__, __LINE__, pipedes[STDOUT_FILENO]);
-      (void) sl_close_fd (FIL__, __LINE__, pipedes[STDIN_FILENO]);
+      (void) close (pipedes[STDOUT_FILENO]);
+      (void) close (pipedes[STDIN_FILENO]);
       (void) waitpid (task->pid, NULL, 0);
       task->pid = 0;
@@ -569,5 +492,5 @@
   PDBG_D(task->pipeFD);
 
-  task->pipeTI = sl_make_ticket(FIL__, __LINE__, task->pipeFD, _("pipe"), outf);
+  task->pipeTI = sl_make_ticket(task->pipeFD, _("pipe"));
 
   flags = (int) retry_fcntl (FIL__, __LINE__, task->pipeFD, F_GETFL, 0);
@@ -595,15 +518,10 @@
   char  infomsg[256];
 
-#ifdef WCONTINUED
-      int wflags = WNOHANG|WUNTRACED|WCONTINUED;
-#else
-      int wflags = WNOHANG|WUNTRACED;
-#endif
-
   SL_ENTER(_("sh_ext_pclose"));
 
-  PDBG_OPEN;
+  PDBGC_OPEN;
   PDBG_S(" -> pclose");
   (void) fflush(task->pipe);
+  (void) fclose(task->pipe);
   if (!SL_ISERROR(task->pipeTI))
     (void) sl_close(task->pipeTI);
@@ -618,43 +536,39 @@
 
     nochmal:
-      retval = waitpid(task->pid, &(task->exit_status), wflags);
+      retval = waitpid(task->pid, &(task->exit_status), WNOHANG|WUNTRACED);
       /*@-bufferoverflowhigh@*/
       if (task->pid == retval)
 	{
-#ifndef USE_UNO
 	  if (WIFEXITED(task->exit_status) != 0)
 	    {
 	      task->exit_status = WEXITSTATUS(task->exit_status);
-	      if ((flag_err_debug == S_TRUE) || (task->exit_status != 0))
-		sl_snprintf(infomsg, sizeof(infomsg),
-			    _("Subprocess exited normally with status %d"),
-			    task->exit_status);
+	      if ((flag_err_debug == SL_TRUE) || (task->exit_status != 0))
+		sprintf(infomsg,                         /* known to fit  */
+			_("Subprocess exited normally with status %d"),
+			task->exit_status);
 	    }
 	  else if (WIFSIGNALED(task->exit_status) != 0)
 	    {
-	      sl_snprintf(infomsg, sizeof(infomsg),
-			  _("Subprocess terminated by signal %d"),
-			  WTERMSIG(task->exit_status));
+	      sprintf(infomsg,                           /* known to fit  */
+		      _("Subprocess terminated by signal %d"),
+		      WTERMSIG(task->exit_status));
 	      task->exit_status = EXIT_FAILURE;
 	    }
 	  else if (WIFSTOPPED(task->exit_status) != 0)
 	    {
-	      sl_snprintf(infomsg, sizeof(infomsg),
-			  _("Subprocess stopped by signal %d, killing"),
-			  WSTOPSIG(task->exit_status));
+	      sprintf(infomsg,                           /* known to fit  */
+		      _("Subprocess stopped by signal %d, killing"),
+		      WSTOPSIG(task->exit_status));
 	      task->exit_status = EXIT_FAILURE;
 	      (void) aud_kill (FIL__, __LINE__, task->pid, 9);
 	      (void) retry_msleep (0, 30);
-	      (void) waitpid (task->pid, NULL, wflags);
+	      (void) waitpid (task->pid, NULL, WNOHANG|WUNTRACED);
 	    }
 	  else
 	    {
-	      sl_snprintf(infomsg, sizeof(infomsg),
-			  _("Subprocess exit status unknown"));
+	      sprintf(infomsg,                           /* known to fit  */
+		      _("Subprocess exit status unknown"));
 	      task->exit_status = EXIT_FAILURE;
 	    }
-#else
-	  task->exit_status = EXIT_FAILURE;
-#endif 
 	}
       else if (0 == retval)
@@ -667,6 +581,6 @@
 	    }
 	  (void) aud_kill (FIL__, __LINE__, task->pid, 9);
-	  sl_snprintf(infomsg, sizeof(infomsg),
-		      _("Subprocess not yet exited, killing"));
+	  sprintf(infomsg,                               /* known to fit  */
+		  _("Subprocess not yet exited, killing"));
 	  task->exit_status = EXIT_FAILURE;
 	  (void) waitpid (task->pid, NULL, 0);
@@ -674,11 +588,11 @@
       else
 	{
-	  sl_snprintf(infomsg, sizeof(infomsg),
-		      _("Waitpid returned error %d\n"), errno);
+	  sprintf(infomsg,                               /* known to fit  */
+		  _("Waitpid returned error %d\n"), errno);
 	  task->exit_status = EXIT_FAILURE;
 	}
       /*@+bufferoverflowhigh@*/
       status = task->exit_status;
-      if (flag_err_debug == S_TRUE)
+      if (flag_err_debug == SL_TRUE)
 	{
 	  sh_error_handle(SH_ERR_ALL, FIL__, __LINE__, task->exit_status, 
@@ -720,7 +634,5 @@
       tas->argv[i]          = NULL;
       tas->envv[i]          = NULL;
-#if 0
       tas->trusted_users[i] = (uid_t) -1;
-#endif
     }
 
@@ -734,5 +646,5 @@
 
 
-int sh_ext_tas_add_envv(sh_tas_t * tas, const char * key, const char * val)
+int sh_ext_tas_add_envv(sh_tas_t * tas, char * key, char * val)
 {
   size_t sk = 0, sv = 0;
@@ -751,8 +663,4 @@
     sv = strlen(val) + 1;
 
-  if (!sl_ok_adds(sk, sv))
-    {
-      SL_RETURN (-1, _("sh_ext_tas_add_envv"));
-    }
   si = tas->envc;
   tas->envv[si] = SH_ALLOC(sk + sv);
@@ -789,5 +697,5 @@
 }
 
-int sh_ext_tas_add_argv(sh_tas_t * tas, const char * val)
+int sh_ext_tas_add_argv(sh_tas_t * tas, char * val)
 {
   size_t sv = 0;
@@ -814,5 +722,5 @@
 }
 
-void sh_ext_tas_command(sh_tas_t * tas, const char * command)
+void sh_ext_tas_command(sh_tas_t * tas, char * command)
 {
   size_t len = sl_strlen(command);
@@ -843,175 +751,4 @@
 }
 
-static void task_init (sh_tas_t * task)
-{
-  sh_ext_tas_init(task);
-
-  (void) sh_ext_tas_add_envv (task, _("SHELL"), 
-			      _("/bin/sh")); 
-  (void) sh_ext_tas_add_envv (task, _("PATH"),  
-			      _("/sbin:/bin:/usr/sbin:/usr/bin:/usr/ucb")); 
-  (void) sh_ext_tas_add_envv (task, _("IFS"), " \n\t"); 
-
-  if (sh.timezone != NULL)
-    {
-      (void) sh_ext_tas_add_envv(task,  "TZ", sh.timezone);
-    }
-  return;
-}
-
-int sh_ext_popen_init (sh_tas_t * task, const char * command, char * argv0, ...)
-{
-  va_list vl;
-  int status;
-
-  task_init (task);
-  
-  if (!argv0)
-    {
-      sh_ext_tas_command(task,  _("/bin/sh"));
-
-      (void) sh_ext_tas_add_argv(task,  _("/bin/sh"));
-      (void) sh_ext_tas_add_argv(task,  _("-c"));
-      (void) sh_ext_tas_add_argv(task,  command);
-    }
-  else
-    {
-      char * s;
-
-      sh_ext_tas_command(task,  command);
-
-      (void) sh_ext_tas_add_argv(task, argv0);
-
-      va_start (vl, argv0);
-      s = va_arg (vl, char * );
-      while (s != NULL)
-	{
-	  (void) sh_ext_tas_add_argv(task, s);
-	  s = va_arg (vl, char * );
-	}
-      va_end (vl);
-
-    }
-  task->rw = 'r';
-  task->fork_twice = S_FALSE;
-
-  status = sh_ext_popen(task);
-
-  return status;
-}
-
-/* Execute a system command */
-
-int sh_ext_system (char * command, char * argv0, ...)
-{
-  sh_tas_t task;
-  int    status;
-  va_list vl;
-  char * s;
-
-  SL_ENTER(_("sh_ext_system"));
-
-  task_init (&task);
-  
-  sh_ext_tas_command(&task,  command);
-
-  (void) sh_ext_tas_add_argv(&task, argv0);
-  
-  va_start (vl, argv0);
-  s = va_arg (vl, char * );
-  while (s != NULL)
-    {
-      (void) sh_ext_tas_add_argv(&task, s);
-      s = va_arg (vl, char * );
-    }
-  va_end (vl);
-
-  task.rw = 'r';
-  task.fork_twice = S_FALSE;
-
-  status = sh_ext_popen(&task);
-
-  if (status != 0)
-    {
-      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, status, MSG_E_SUBGEN, 
-                      _("Could not execute command"), _("sh_ext_system"));
-      SL_RETURN ((-1), _("sh_ext_system"));
-    }
-
-  /* close pipe and return exit status
-   */
-  (void) sh_ext_pclose(&task);
-  sh_ext_tas_free (&task);
-  SL_RETURN ((status), _("sh_ext_system"));
-}
-
-/* Execute command, return first line of output
- * ifconfig | grep -1 lo | tail -n 1 | sed s/.*inet addr:\([0-9.]*\)\(.*\)/\1/
- */
-char * sh_ext_popen_str (const char * command)
-{
-  sh_tas_t task;
-  struct  sigaction  new_act;
-  struct  sigaction  old_act;
-  char * out = NULL;
-  int    status;
-
-  SL_ENTER(_("sh_ext_popen_str"));
-
-  status = sh_ext_popen_init (&task, command, NULL, NULL);
-
-  if (status != 0)
-    {
-      sh_error_handle(SH_ERR_ALL, FIL__, __LINE__, status, MSG_E_SUBGEN, 
-                      _("Could not open pipe"), _("sh_ext_popen_str"));
-      SL_RETURN ((NULL), _("sh_ext_popen_str"));
-    }
-
-   /* ignore SIGPIPE (instead get EPIPE if connection is closed)
-    */
-   new_act.sa_handler = SIG_IGN;
-   new_act.sa_flags   = 0;
-   sigemptyset( &new_act.sa_mask );
-   
-   (void) retry_sigaction (FIL__, __LINE__, SIGPIPE, &new_act, &old_act);
-   
-  /* read from the open pipe
-   */
-  if (task.pipe != NULL)
-    {
-      int try = 1200; /* 1000 * 0.1 = 120 sec */
-      sh_string * s = sh_string_new(0);
-      do {
-	sh_string_read(s, task.pipe, 0);
-	if (sh_string_len(s) == 0)
-	  {
-	    /* cppcheck-suppress syntaxError */
-	    --try; retry_msleep(0, 100);
-	  }
-      } while (sh_string_len(s) == 0 && try != 0);
-
-      if (sh_string_len(s) == 0)
-	{
-	  sh_error_handle(SH_ERR_ALL, FIL__, __LINE__, status, MSG_E_SUBGEN, 
-			  _("No output from command"), _("sh_ext_popen_str"));
-	}
-
-      out = sh_util_strdup(sh_string_str(s));
-      sh_string_destroy(&s);
-    }
-
-  /* restore old signal handler
-   */
-  (void) retry_sigaction (FIL__, __LINE__, SIGPIPE, &old_act, NULL);
-
-  /* close pipe and return exit status
-   */
-  (void) sh_ext_pclose(&task);
-  sh_ext_tas_free (&task);
-  SL_RETURN ((out), _("sh_ext_popen_str"));
-}
-
-
-
 
 /* ---------------  EXTERN STUFF ------------------- */
@@ -1023,6 +760,10 @@
   char     type[4];
 
-  sh_filter_type * filter;
-
+  int      for_c;
+  char   * for_v[32];
+  int      fand_c;
+  char   * fand_v[32];
+  int      fnot_c;
+  char   * fnot_v[32];
   time_t   deadtime;
   time_t   last_run;
@@ -1052,4 +793,5 @@
 sh_com_t * command_init(void)
 {
+  int         i;
   uid_t       ff_euid;
   sh_com_t  * ext_com = NULL;
@@ -1061,5 +803,5 @@
   if (!ext_com)
     {
-      SL_RETURN( NULL, _("command_init"));
+      SL_RETURN( NULL, ("command_init"));
     }
 
@@ -1067,19 +809,25 @@
 
   (void) sl_get_euid(&ff_euid);
-#if 0
   ext_com->tas.trusted_users[0] = (uid_t) 0;
   ext_com->tas.trusted_users[1] = (uid_t) (ff_euid);
-#endif
 
   /* ------------------------------------------------- */
 
   set3(ext_com->type, 'l', 'o', 'g');
-  ext_com->filter       = NULL;
+  ext_com->for_c        = 0;
+  ext_com->fand_c       = 0;
+  ext_com->fnot_c       = 0;
   ext_com->deadtime     = 0;
   ext_com->last_run     = 0;
 
+  for (i = 0; i < 32; ++i)
+    {
+      ext_com->for_v[i]         = NULL;
+      ext_com->fand_v[i]        = NULL;
+      ext_com->fnot_v[i]        = NULL;
+    }
   ext_com->next             = NULL;
 
-  SL_RETURN( ext_com, _("command_init"));
+  SL_RETURN( ext_com, ("command_init"));
 }
 
@@ -1094,8 +842,6 @@
 
 static
-int sh_ext_add_envv(const char * key, const char * val)
-{
-  int retval; 
-
+int sh_ext_add_envv(char * key, char * val)
+{
   SL_ENTER(_("sh_ext_add_envv"));
 
@@ -1107,10 +853,7 @@
     }
 
-  retval = sh_ext_tas_add_envv(&(ext_coms->tas), key, val);
-
-  if (retval >= 0) 
-    retval = 0;
-
-  SL_RETURN (retval, _("sh_ext_add_envv"));
+  (void) sh_ext_tas_add_envv(&(ext_coms->tas), key, val);
+
+  SL_RETURN (0, _("sh_ext_add_envv"));
 }
 
@@ -1118,5 +861,5 @@
 
 static 
-int sh_ext_init(const char * command)
+int sh_ext_init(char * command)
 {
   sh_com_t * retval;
@@ -1153,11 +896,7 @@
 
 static
-int sh_ext_uid (const char * user, /*@out@*/uid_t * uid, /*@out@*/gid_t * gid)
-{
-  struct passwd *  tempres;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  struct passwd    pwd;
-  char           * buffer = SH_ALLOC(SH_PWBUF_SIZE);
-#endif
+int sh_ext_uid (char * user, /*@out@*/uid_t * uid, /*@out@*/gid_t * gid)
+{
+  struct passwd * tempres;
 
   SL_ENTER(_("sh_ext_uid"));
@@ -1167,15 +906,7 @@
   if (user == NULL)
     {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      SH_FREE(buffer);
-#endif
       SL_RETURN (-1, _("sh_ext_uid"));
     }
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  sh_getpwnam_r(user, &pwd, buffer, SH_PWBUF_SIZE, &tempres);
-#else
   tempres = sh_getpwnam(user);
-#endif
 
   if (NULL != tempres) 
@@ -1183,13 +914,7 @@
       *uid = tempres->pw_uid;  
       *gid = tempres->pw_gid;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      SH_FREE(buffer);
-#endif
       SL_RETURN (0, _("sh_ext_uid"));
     } 
 
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  SH_FREE(buffer);
-#endif
   SL_RETURN (-1, _("sh_ext_uid"));
 }
@@ -1197,11 +922,9 @@
 
 static
-int sh_ext_add (const char * argstring, int * ntok, char * stok[])
+int sh_ext_add (char * argstring, int * ntok, char * stok[])
 {
   int    i = 0;
   size_t s;
   char * p;
-  char * new;
-  size_t len;
 
   SL_ENTER(_("sh_ext_add"));
@@ -1212,23 +935,10 @@
     }
 
-  len = strlen(argstring) + 1;
-  new = SH_ALLOC(len);
-  sl_strlcpy(new, argstring, len); 
-
   do
     {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-      char * saveptr;
       if (i == 0)
-	p = strtok_r (new, ", \t", &saveptr);
-      else
-	p = strtok_r (NULL, ", \t", &saveptr);
-#else
-      if (i == 0)
-	p = strtok (new, ", \t");
+	p = strtok (argstring, ", \t");
       else
 	p = strtok (NULL, ", \t");
-#endif
-
       if (p == NULL)
 	break;
@@ -1247,5 +957,4 @@
 
   *ntok = i;
-  SH_FREE(new);
 
   SL_RETURN (0, _("sh_ext_add"));
@@ -1262,5 +971,5 @@
  * -- start a new external command, and add it to the list
  */ 
-int sh_ext_setcommand(const char * cmd)
+int sh_ext_setcommand(char * cmd)
 {
   int i;
@@ -1280,4 +989,5 @@
 int sh_ext_cleanup(void)
 {
+  int i;
   sh_com_t * retval;
 
@@ -1291,6 +1001,10 @@
       sh_ext_tas_free (&(retval->tas));
 
-      if (retval->filter)
-	sh_filter_free (retval->filter);
+      for (i = 0; i < 32; ++i)
+	{
+	  if (NULL != retval->for_v[i])  SH_FREE(retval->for_v[i]);
+	  if (NULL != retval->fand_v[i]) SH_FREE(retval->fand_v[i]);
+	  if (NULL != retval->fnot_v[i]) SH_FREE(retval->fnot_v[i]);
+	}
 
       SH_FREE(retval);
@@ -1302,49 +1016,31 @@
 
 /*
- * -- explicitely close a command
- */
-int sh_ext_close_command (const char * str)
-{
-  (void) str;
+ * -- add keywords to the OR filter
+ */
+int sh_ext_add_or (char * str)
+{
   if (ext_coms == NULL || ext_failed == (-1))
     return (-1);
-  ext_failed = (-1);
-  return 0;
+  return (sh_ext_add (str, &(ext_coms->for_c), ext_coms->for_v));
 }
 
 /*
- * -- add keywords to the OR filter
- */
-int sh_ext_add_or (const char * str)
+ * -- add keywords to the AND filter
+ */
+int sh_ext_add_and (char * str)
 {
   if (ext_coms == NULL || ext_failed == (-1))
     return (-1);
-  if (ext_coms->filter == NULL)
-    ext_coms->filter = sh_filter_alloc();
-  return (sh_filter_add(str, ext_coms->filter, SH_FILT_OR));
+  return (sh_ext_add (str, &(ext_coms->fand_c), ext_coms->fand_v));
 }
 
 /*
- * -- add keywords to the AND filter
- */
-int sh_ext_add_and (const char * str)
+ * -- add keywords to the NOT filter
+ */
+int sh_ext_add_not (char * str)
 {
   if (ext_coms == NULL || ext_failed == (-1))
     return (-1);
-  if (ext_coms->filter == NULL)
-    ext_coms->filter = sh_filter_alloc();
-  return (sh_filter_add(str, ext_coms->filter, SH_FILT_AND));
-}
-
-/*
- * -- add keywords to the NOT filter
- */
-int sh_ext_add_not (const char * str)
-{
-  if (ext_coms == NULL || ext_failed == (-1))
-    return (-1);
-  if (ext_coms->filter == NULL)
-    ext_coms->filter = sh_filter_alloc();
-  return (sh_filter_add(str, ext_coms->filter, SH_FILT_NOT));
+  return (sh_ext_add (str, &(ext_coms->fnot_c), ext_coms->fnot_v));
 }
 
@@ -1352,5 +1048,5 @@
  * -- add keywords to the CL argument list
  */
-int sh_ext_add_argv (const char * str)
+int sh_ext_add_argv (char * str)
 {
   if (ext_coms == NULL || ext_failed == (-1))
@@ -1362,9 +1058,11 @@
  * -- add a path to the environment
  */
-int sh_ext_add_default (const char * dummy)
-{
-  char * p = NULL;
+int sh_ext_add_default (char * dummy)
+{
+  /* while this assignment looks ridiculous, it is here to avoid
+   * an 'unused parameter' warning
+   */
+  char * p = (dummy == NULL ? dummy : NULL);
   int    i;
-  char   dir[SH_PATHBUF];
 
   SL_ENTER(_("sh_ext_add_default"));
@@ -1374,11 +1072,9 @@
       SL_RETURN(0, _("sh_ext_add_default"));
     }
-  p = sh_unix_getUIDdir (SH_ERR_ERR, (uid_t) ext_coms->tas.run_user_uid, 
-			 dir, sizeof(dir));
+  p = sh_unix_getUIDdir (SH_ERR_ERR, (uid_t) ext_coms->tas.run_user_uid);
   if (p)
     (void) sh_ext_add_envv (_("HOME"), p);
   (void) sh_ext_add_envv (_("SHELL"), _("/bin/sh")); 
-  (void) sh_ext_add_envv (_("PATH"),  _("/sbin:/bin:/usr/sbin:/usr/bin")); 
-  (void) sh_ext_add_envv (_("IFS"), " \n\t"); 
+  (void) sh_ext_add_envv (_("PATH"),  _("/sbin:/usr/sbin:/bin:/usr/bin")); 
   i = (p == NULL ? (-1) :  0);
   SL_RETURN(i, _("sh_ext_add_default"));
@@ -1388,8 +1084,7 @@
  * -- add an environment variable
  */
-int sh_ext_add_environ (const char * str)
+int sh_ext_add_environ (char * str)
 {
   int i;
-
   SL_ENTER(_("sh_ext_add_environ"));
   i = sh_ext_add_envv (NULL, str);
@@ -1400,5 +1095,5 @@
  * -- set deadtime
  */
-int sh_ext_deadtime (const char * str)
+int sh_ext_deadtime (char * str)
 {
   long    deadtime = 0;
@@ -1409,14 +1104,14 @@
   if (ext_coms == NULL || ext_failed == (-1) || str == NULL)
     {
-      SL_RETURN (-1, _("sh_ext_deadtime"));
+      SL_RETURN (-1, ("sh_ext_deadtime"));
     }
   deadtime = strtol(str, &tail, 10);
   if (tail == str || deadtime < 0 || deadtime == LONG_MAX)
     {
-      SL_RETURN (-1, _("sh_ext_deadtime"));
+      SL_RETURN (-1, ("sh_ext_deadtime"));
     }
   
   ext_coms->deadtime = (time_t) deadtime;  
-  SL_RETURN (0, _("sh_ext_deadtime"));  
+  SL_RETURN (0, ("sh_ext_deadtime"));  
 }
 
@@ -1424,5 +1119,5 @@
  * -- define type
  */
-int sh_ext_type (const char * str)
+int sh_ext_type (char * str)
 {
   SL_ENTER(_("sh_ext_type"));
@@ -1459,5 +1154,5 @@
  * -- define checksum
  */
-int sh_ext_checksum (const char * str)
+int sh_ext_checksum (char * str)
 {
   SL_ENTER(_("sh_ext_checksum"));
@@ -1480,5 +1175,5 @@
  * -- choose privileges
  */
-int sh_ext_priv (const char * c)
+int sh_ext_priv (char * c)
 {
 
@@ -1507,19 +1202,56 @@
 static int sh_ext_filter (char * message, sh_com_t * task)
 {
+  int i;
+  int j = 0;
   time_t now_time;
 
   SL_ENTER(_("sh_ext_filter"));
 
-  if (task->filter)
-    {
-      if (0 != sh_filter_filter (message, task->filter))
+  /* Presence of any of these keywords prevents execution.
+   */
+  if (task->fnot_c > 0)
+    {
+      for (i = 0; i < task->fnot_c; ++i)
+	{
+	  if (NULL != sl_strstr(message, task->fnot_v[i]))
+	    {
+	      SL_RETURN ((-1), _("sh_ext_filter"));
+	    }
+	}
+    }
+
+  /* Presence of all of these keywords is required for execution.
+   */
+  if (task->fand_c > 0)
+    {
+      j = 0;
+
+      for (i = 0; i < task->fand_c; ++i)
+	if (NULL != sl_strstr(message, task->fand_v[i]))
+	  ++j;
+
+      if (j != task->fand_c)
 	{
 	  SL_RETURN ((-1), _("sh_ext_filter"));
 	}
-    }
-
-  /* Filter passed, check deadtime */
-
-  if (task->deadtime != (time_t) 0)
+
+    }
+
+  /* Presence of at least one of these keywords is required for execution.
+   */
+  if (task->for_c > 0)
+    {
+      for (i = 0; i < task->for_c; ++i)
+	{
+	  if (NULL != sl_strstr(message, task->for_v[i]))
+	    {
+	      goto checkdeadtime;
+	    }
+	}
+      SL_RETURN ((-1), _("sh_ext_filter"));
+    }
+
+ checkdeadtime:
+  if (task->deadtime != (time_t) 0)   /* deadtime */
     {
       now_time = time (NULL);
@@ -1554,5 +1286,4 @@
   int        status = 0;
   char     * tmp;
-  char errbuf[SH_ERRBUF_SIZE];
 
   static  int some_error = 0;
@@ -1583,5 +1314,4 @@
   while (listval != NULL)
     {
-      PDBG_OPEN;
       PDBG(-2);
       if (t1 == listval->type[0] &&
@@ -1595,5 +1325,5 @@
 	    {
 	      sh_error_handle((-1), FIL__, __LINE__, caperr, MSG_E_SUBGEN,
-			      sh_error_message (caperr, errbuf, sizeof(errbuf)), 
+			      sh_error_message (caperr), 
 			      _("sl_get_cap_sub"));
 	    }
@@ -1674,5 +1404,5 @@
 	    {
 	      sh_error_handle((-1), FIL__, __LINE__, caperr, MSG_E_SUBGEN,
-			      sh_error_message (caperr, errbuf, sizeof(errbuf)), 
+			      sh_error_message (caperr), 
 			      _("sl_drop_cap_sub"));
 	    }
